﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Web;

public class DataAccess
{
	public DataAccess()
	{
	}

	public static byte[] GetImageByID(int ImageID)
	{
		string cnn = 
			ConfigurationManager.ConnectionStrings["LocalSqlServer"].ConnectionString;

		using (SqlConnection connection = new SqlConnection(cnn))
		{
			using (SqlCommand command = new SqlCommand("dbo.up_GetImageByID", connection))
			{
				command.CommandType = CommandType.StoredProcedure;
				command.Parameters.Add(new SqlParameter("@ID", ImageID));
				connection.Open();

				object result = command.ExecuteScalar();

				try
				{
					return (byte[])result;
				}
				catch
				{
					return null;
				}
			}
		}
	}

	public static void InsertImage(string description, byte[] imageAsBytes)
	{
		string cnn = 
			ConfigurationManager.ConnectionStrings["LocalSqlServer"].ConnectionString;

		using (SqlConnection connection = new SqlConnection(cnn))
		{
			using (SqlCommand command = new SqlCommand("dbo.up_InsertImage", connection))
			{
				command.CommandType = CommandType.StoredProcedure;
				command.Parameters.Add(new SqlParameter("@description", description));
				command.Parameters.Add(new SqlParameter("@imageAsBytes", imageAsBytes));
				connection.Open();
				command.ExecuteNonQuery();
			}
		}
	}

	public static List<ImageData> ListImages()
	{
		string cnn = 
			ConfigurationManager.ConnectionStrings["LocalSqlServer"].ConnectionString;

		using (SqlConnection connection = new SqlConnection(cnn))
		{
			using (SqlCommand command = new SqlCommand("dbo.up_ListImages", connection))
			{
				command.CommandType = CommandType.StoredProcedure;
				connection.Open();

				List<ImageData> list = new List<ImageData>();

				using (SqlDataReader reader = command.ExecuteReader())
				{
					while (reader.Read())
					{
						ImageData item = new ImageData() 
						{ 
							ID = (int)reader["ID"], 
							Description = (string)reader["Description"] 
						};

						list.Add(item);
					}
				}
				return list;
			}
		}
	}

	public class ImageData
	{
		public int ID { get; set; }
		public string Description { get; set; }

		public ImageData() { }
	}
}