﻿Imports System
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data
Imports System.Data.SqlClient
Imports System.IO
Imports System.Linq
Imports System.Web

Public Class DataAccess

    Public Shared Function GetImageByID(ByVal ImageID As Integer) As Byte()

        Using connection As SqlConnection = New SqlConnection(ConfigurationManager.ConnectionStrings("LocalSqlServer").ConnectionString)

            Using command As SqlCommand = New SqlCommand("dbo.up_GetImageByID", connection)

                command.CommandType = CommandType.StoredProcedure
                command.Parameters.Add(New SqlParameter("@ID", ImageID))
                connection.Open()

                Dim result As Object = command.ExecuteScalar
                Try
                    Return CType(result, Byte())
                Catch ex As System.Exception
                    Return Nothing
                End Try
            End Using
        End Using
    End Function

    Public Shared Sub InsertImage(ByVal description As String, ByVal imageAsBytes() As Byte)

        Using connection As SqlConnection = New SqlConnection(ConfigurationManager.ConnectionStrings("LocalSqlServer").ConnectionString)

            Using command As SqlCommand = New SqlCommand("dbo.up_InsertImage", connection)

                command.CommandType = CommandType.StoredProcedure
                command.Parameters.Add(New SqlParameter("@description", description))
                command.Parameters.Add(New SqlParameter("@imageAsBytes", imageAsBytes))
                connection.Open()
                command.ExecuteNonQuery()
            End Using
        End Using
    End Sub

    Public Shared Function ListImages() As List(Of ImageData)

        Using connection As SqlConnection = New SqlConnection(ConfigurationManager.ConnectionStrings("LocalSqlServer").ConnectionString)

            Using command As SqlCommand = New SqlCommand("dbo.up_ListImages", connection)

                command.CommandType = CommandType.StoredProcedure
                connection.Open()

                Dim list As List(Of ImageData) = New List(Of ImageData)()

                Using reader As SqlDataReader = command.ExecuteReader

                    While reader.Read

                        Dim item As ImageData = New ImageData(CType(reader("ID"), Integer), CType(reader("Description"), String))
                        list.Add(item)
                    End While
                End Using

                Return list
            End Using
        End Using
    End Function
End Class

Public Class ImageData

    Public Sub New(ByVal id As Integer, ByVal description As String)

        MyBase.New()

        Me._id = id
        Me._description = description
    End Sub

    Private _id As Integer
    Private _description As String

    Public Property ID() As Integer
        Get
            Return _id
        End Get
        Set(ByVal value As Integer)
            _id = value
        End Set
    End Property

    Public Property Description() As String
        Get
            Return _description
        End Get
        Set(ByVal value As String)
            _description = value
        End Set
    End Property
End Class
