﻿Imports System.IO

Partial Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' bind the list of images from the database
        If Not IsPostBack Then
            repImages.DataSource = DataAccess.ListImages
        End If

        DataBind()
    End Sub

    ''' <summary>
    ''' Method to handle pulling the files from the request and send them to the database
    ''' </summary>
    Private Sub HandleUploadedFile()

        ' get the file instance
        Dim fi As HttpPostedFile = Request.Files.Get(0)

        ' get the description
        Dim desc As String = Description.Text

        ' create a byte array to store the file bytes
        Dim fileBytes As Byte() = New Byte((fi.ContentLength) - 1) {}

        ' fill the byte array
        Dim stream As System.IO.Stream = fi.InputStream
        stream.Read(fileBytes, 0, fi.ContentLength)

        ' insert the image
        DataAccess.InsertImage(desc, fileBytes)

        ' bind the image list
        repImages.DataSource = DataAccess.ListImages
        DataBind()

        ' clean up
        description.Text = ""
        fileBytes = Nothing
    End Sub

    Protected Sub repImages_ItemDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.RepeaterItemEventArgs) Handles repImages.ItemDataBound

        Dim item As ImageData = CType(e.Item.DataItem, ImageData)

        Dim aspImage As Image = CType(e.Item.FindControl("imageThumb"), Image)
        Dim aspLabel As Label = CType(e.Item.FindControl("labelDescription"), Label)

        ' set the image control properties
        If (Not (aspImage) Is Nothing) Then
            aspImage.ImageUrl = String.Format("~/Thumbnail.ashx?id={0}", item.ID)
            aspImage.AlternateText = item.Description
            aspImage.Visible = True
        End If
        ' set the image title
        If (Not (aspLabel) Is Nothing) Then
            aspLabel.Text = item.Description
            aspLabel.Visible = True
        End If
    End Sub

    Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click

        If (IsPostBack) Then
            HandleUploadedFile()
        End If
    End Sub
End Class
